import { Container, Token } from 'ditox';
/**
 * @category Hook
 *
 * Returns a dependency container. Throws an error in case the container is not provided.
 */
export declare function useDependencyContainer(mode: 'strict'): Container;
/**
 * @category Hook
 *
 * Returns a dependency container, or `undefined` in case the container is not provided.
 */
export declare function useDependencyContainer(mode?: 'optional'): Container | undefined;
/**
 * @category Hook
 *
 * Returns a dependency by token, or fails with an error.
 */
export declare function useDependency<T>(token: Token<T>): T;
/**
 * @category Hook
 *
 * Returns a dependency by token, or `undefined` in case the dependency is not provided.
 */
export declare function useOptionalDependency<T>(token: Token<T>): T | undefined;
